SHEBANG
# Copyright @BABOLO (C)2002,2003 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: addon.m4,v 1.5 2018/07/03 16:31:01 babolo Exp $

JNTROSTUP(,,,dnl
# jailup rm <dirlist>
# !!! REMOVES jails in <dirlist>)

df=/bin/df

for i in "$@"; do
    jdir="${i}"
    main_dir="${JAILUPDIR}/${jdir}"
    conf_dir="${JAILRODIR}/${jdir}"
    if  [ -n "${CONFSHIFT}" ]; then
        conf_dir="${conf_dir}/${CONFSHIFT}"
    fi
    do="y"
    l=`${grep} -E "^sltS+WS+sltS+WS+${jdir}WS" ${JAILUPRC}` || ${true}
    if  [ -n "${l}" ]; then
        do=''
        echo "Please:"
          ${grep} -E "^sltS+WS+sltS+WS+${jdir}WS" ${JAILUPRC}\
        | ${awk} "{print \"${PREFIX}/etc/rc.d/jailup stop \" \$1, \$3}"
        echo "and deactivate in ${JAILUPRC}:"
        ${grep} -E "^sltS+WS+sltS+WS+${jdir}WS" ${JAILUPRC}
    fi
    for f in /etc/rc.conf /etc/rc.local; do
        l=''
        if  [ -f ${f} ]; then
            l=`${grep} -vE '^WS*#' ${f} | ${grep} -E "${main_dir}"` || ${true}
            if  [ -n "${l}" ]; then
                do=''
                echo "Please remove or comment in ${f}:"
                ${grep} -vE '^WS*#' ${f} | ${grep} -E "${main_dir}"
            fi
            l=`${grep} -vE '^WS*#' ${f} | ${grep} -E "${conf_dir}"` || ${true}
            if  [ -n "${l}" ]; then
                do=''
                echo "Please remove or comment in ${f}:"
                ${grep} -vE '^WS*#' ${f} | ${grep} -E "${conf_dir}"
        fi; fi
    done
    l=`${jun_ctl} dogfi \* ${jdir}`
    l=`${ls} ${l} 2> /dev/null` || ${true}
    ab='y'
    for j in ${l}; do
        if  [ -n "${ab}" ]; then
            ab=''
            echo "Dogs:"
        fi
        echo -n "${j}"
        p=`${head} -1 ${j}`
        if  [ -n "${p}" ]; then
            echo -n ": ${p}"
            if  ${ps} -ax | ${grep} -qE "^ *${p} "; then
                do=''
                echo -n " exists, stop it"
        fi; fi
        echo
    done
    l=''
    if  [ -d "${main_dir}/var/run" ]; then
        l=`${find} "${main_dir}/var/run" -name \*.pid`
    fi
    ab='y'
    for j in ${l}; do
        if  [ -n "${ab}" ]; then
            ab=''
            echo "Pids:"
        fi
        echo -n "${j}"
        p=`${head} -1 ${j}`
        if  [ -n "${p}" ]; then
            echo -n ": ${p}"
            if  ${ps} -ax | ${grep} -qE "^ *${p} "; then
                do=''
                echo -n " exists, stop it"
        fi; fi
        echo
    done
    l=`${df} | ${awk} '{print $6}' | ${grep} -E "^${main_dir}"` || ${true}
    if  [ -n "${l}" ]; then
        do=''
        echo "Please:"
        for j in ${l}; do
            echo "umount ${j}"
        done
    fi
    l=` ${grep} -vE '^WS*#' /etc/fstab\
      | ${grep} -vE '^WS*TX+WS+TX+WS+TX+WS+[-a-z,]*noauto[-a-z,]*'\
      | ${awk} '{print $2}'\
      | ${grep} -E "^${main_dir}"\
      ` || ${true}
    if  [ -n "${l}" ]; then
        do=''
        echo "Please remove or comment in /etc/fstab:"
        for j in ${l}; do
            ${grep} -vE '^WS*#' /etc/fstab\
          | ${grep} -vE '^WS*TX+WS+TX+WS+TX+WS+[-a-z,]*noauto[-a-z,]*'\
          | ${grep} -E "^WS*TX+WS+${j}WS"
        done
    fi
    if  [ -n "${do}" ]; then
        if  [ -e "${main_dir}" ]; then
            ${find} "${main_dir}" -type d | ${xargs} -n 1 ${chflags} noschg,nosunlnk
            ${find} "${main_dir}" -type f | ${xargs} -n 1 ${rmflaged}
            ${rm} -rf "${main_dir}"
        fi
        if  [ -e "${conf_dir}" ]; then
            ${find} "${conf_dir}" -type d | ${xargs} -n 1 ${chflags} noschg,nosunlnk
            ${find} "${conf_dir}" -type f | ${xargs} -n 1 ${rmflaged}
            ${rm} -rf "${conf_dir}"
    fi; fi
done
